///////////////////////////////////////////////////////////////////////

int BlowFishDecode(char *SourceName,char *TargetName, char *Key)
{
    unsigned long L = 1, R = 3, RemLong = 0, FileSize = 0;
    FILE *Source = NULL, *Target = NULL;

    double Process_FileSize, DecodeLoop;
    int StatusCount   = 0;

    // Create BlowFish Object
    BF_BlowFish((unsigned char*)Key, strlen(Key));

    FileSize = Get_FileSize(SourceName) - FlagLenght;

    if((Source = fopen(SourceName,"rb")) == NULL)
    {
        char TempText[1024];
        sprintf(TempText, "BlowFishDecode: Could not open %s for read.", SourceName);
        Error(TempText);

        if(Source)fclose(Source);
        return 0;
    }

    // Calculate How Many Sets Of 8 For Encryption Loop
    Process_FileSize = ( FileSize/sizeof(L) ) / 2;

    // Seek Back To The Beginning, Past Flag
    fseek(Source, FlagLenght, SEEK_SET);

    // Read And Compare Header <nept35>
    fread((char *)&L, sizeof(L), 1, Source);
    fread((char *)&R, sizeof(R), 1, Source);

    //Decrypt Header
    BF_Decrypt(&L, &R);

    /* Compare If Decrypted Correctly,
    If Not Tell User Wrong Key */

    if (L != 15942653 || R != 18753826)
    {
        if(Source)fclose(Source);
        if(Target)fclose(Target);
        return 2;
    }

    // Set file attributes to normal to avoid errors
    SetFileAttributes(TargetName, FILE_ATTRIBUTE_NORMAL);

    if((Target = fopen(TargetName,"wb")) == NULL)
    {
        char TempText[1024];
        sprintf(TempText, "BlowFishDecode: Could not open %s for write.", TargetName);
        Error(TempText);

        if(Source)fclose(Source);
        if(Target)fclose(Target);
        return 0;
    }

    // Because Header Does Not Count Suptract One
    Process_FileSize--;

    // Read Second Header Containing Rem
    fread((char *)&RemLong, 4, 1, Source);

    // Begin Encryption / Decryption
    for(DecodeLoop = 0; DecodeLoop < Process_FileSize; DecodeLoop++)
    {
        // Read 8 Bytes From File
        fread((char *)&L, sizeof(L), 1, Source);
        fread((char *)&R, sizeof(R), 1, Source);

        // Call BlowFish Functions
        BF_Decrypt(&L, &R);

        // Write 8 Bytes To File
        if( DecodeLoop == (Process_FileSize - 1) )
        {
            if (RemLong < 4)
            {
                fwrite((char *)&L, (RemLong), 1, Target);
            }
            else {
                fwrite((char *)&L, sizeof(L), 1, Target);
                fwrite((char *)&R, sizeof(R) - (8-RemLong), 1, Target);
            }
        }
        else {
            fwrite((char *)&L, sizeof(L), 1, Target);
            fwrite((char *)&R, sizeof(R), 1, Target);
        }

        StatusCount++;
        if(StatusCount == 10240)
        {
            PI.StatusValue = (DecodeLoop/(Process_FileSize-1)) * 100;
            StatusCount = 0;
            if(PI.SaveCPUOption) Sleep(10);
        }

        if(PI.CancelFlag == TRUE)
        {
            if(Source)fclose(Source);
            if(Target)fclose(Target);
            return 1;
        }
    }

    //Close Files
    if(Source)fclose(Source);
    if(Target)fclose(Target);

    Sleep(25);
    SendMessage(StatusBar_hWnd, PBM_SETPOS, 100, 0);

    return 1;
}
