//----------------------------------------------------------------

#define PriorityKey  "Software\\NetWorkDLS\\448Delta\\Priority"
#define EncDlgKey    "Software\\NetWorkDLS\\448Delta\\EncryptDialog"
#define DecDlgKey    "Software\\NetWorkDLS\\448Delta\\DecryptDialog"
#define StatDlgKey   "Software\\NetWorkDLS\\448Delta\\StatusDialog"
#define PathKey      "Software\\NetWorkDLS\\448Delta\\Path"

#define TitleCaption "448Delta Encryption"  // Application Title
#define MutexName    "448Delta_Encryption"  // Application Mutex Name
#define FileVersion  "1.0.2.8"              // Application Version

#define FinishedWE   "Finished with errors!"
#define WrongPWCD    "Wrong Password, Can't Decrypt!"

#define FlagLenght   5
#define Reserved     "0x15|"
#define ENCFlag      "0x24|"
#define PACFlag      "0x33|"
#define ENCCompress  "0x42|"
#define PACCompress  "0x51|"

#define MegaByte     1048576  // One Megabyte (1,048,576 Bytes)

/* Evaluation
#define MaxFileSize  1 * MegaByte
#define MaxFiles     5
#define BufferSize   5120
*/

///* Complete Release
#define MaxFileSize  250 * MegaByte
#define MaxFiles     10240
#define BufferSize   5120
//*/

//---------------------(HWND & INSTANCE Definitions)
HINSTANCE MainInstance    = NULL;     // WinMain (Application) Instance

HWND StatusBar_hWnd       = NULL;

HWND EncryptDialog_hWnd   = NULL;
HWND DecryptDialog_hWnd   = NULL;
HWND StatusDialog_hWnd    = NULL;
HWND EvalDialog_hWnd      = NULL;

//---------------------(Function Prototypes)
void Error(char *);
BOOL SetPriority(void);

DWORD WINAPI PasswordDialog_Thread(LPVOID);
HANDLE PasswordDialog_Thread_Handle;
DWORD PasswordDialog_Thread_ID;

DWORD WINAPI StartProcess_Thread(LPVOID);
HANDLE StartProcess_Thread_Handle;
DWORD StartProcess_Thread_ID;

BOOL StartProcess(void);

//---------------------(Structure Prototypes)
struct _448ProcessInfo{
    BOOL CompressOption;
    BOOL CreateSelfOption;
    BOOL DeleteSourceOption;
    BOOL SaveCPUOption;
    BOOL UsePriorityOption;
    BOOL DestroyTempOption;

    char TempFile1[257];
    char TempFile2[257];

    HWND StatusText_hWnd;
    HWND OKCancelButton_hWnd;

    BOOL CancelFlag;
    BOOL ErrorFlag;
    BOOL CompleteFlag;
    BOOL ReadyToProcess;

    double StatusValue;
    double LastValue;

    char *AfterText;
    char *StatusText;
    char *GlobalTarget;
    char *GlobalSource;
    char *Password;

    int FileFlagResult;
    int PreCheckResult;

}; _448ProcessInfo PI;

//---------------------(Dialog Prototypes)
BOOL CALLBACK EncryptDialog(HWND, UINT, WPARAM, LPARAM);
BOOL CALLBACK DecryptDialog(HWND, UINT, WPARAM, LPARAM);
BOOL CALLBACK StatusDialog(HWND, UINT, WPARAM, LPARAM);
BOOL CALLBACK EvalDialog(HWND, UINT, WPARAM, LPARAM);

//----------------------------------------------------------------

