// BOOL StartProcess(void);
// DWORD WINAPI StartProcess_Thread(LPVOID xData)

///////////////////////////////////////////////////////////////////////////////////////////

BOOL StartProcess(void)
{
    int LocalLoop = 0;
    while(1)
    {
        BOOL Exist = FALSE;

        sprintf(PI.TempFile1, "%s\\%s", Get_TempDirectory(), GenerateFileName(433) );
        sprintf(PI.TempFile2, "%s\\%s", Get_TempDirectory(), GenerateFileName(667) );

        if( FileAccess(PI.TempFile1, FExist) || FileAccess(PI.TempFile2, FExist) )
            Exist = TRUE;

        if( strcmp(PI.TempFile1, PI.TempFile2) == 0)
            Exist = TRUE;

        if(!Exist) break;

        if(LocalLoop == 25)
        {
            Error("Temporary file assignment error.");
            PI.ErrorFlag = TRUE;
            return FALSE;
        }

        LocalLoop++;
    }

    int Result       = 0;
    float FileSize   = 0;
    char *StatusText = NULL;

    /*  PI.PreCheckResult
        0: Error Occured
        1: Directory
        2: Encrypted File
        3: Packed, Encrypted Directory
        4: Compressed, Encrypted File
        5: Packed, Compressed, Encrypted Directory
        6: Non-448Delta File (Unencrypted)
    */

    /*  PI.FileFlagResult
        1: Pack, Encrypt Directory
        2: Pack, Compress, Encrypt Directory
        3: Encrypt File
        4: Compressed, Encrypted File
    */

    Sleep(500); // Try To Give The Status Dialog A Chance To Appear

    StatusText = (char *) calloc(1024, 1);

    //------------------------------------------------------------------------------------

    if( !SetPriority()) return FALSE;

    if(PI.PreCheckResult == 1) // Directory
    {
        Result = PackFiles(PI.GlobalSource, PI.TempFile1);
        if(!Result)
        {
            PI.ErrorFlag = TRUE;
            PI.AfterText = FinishedWE;
            return FALSE;
        }

        if(PI.CancelFlag == TRUE)
        {
            PI.CompleteFlag = TRUE;
            return FALSE;
        }

        if(PI.CompressOption == TRUE)
        {
            PI.FileFlagResult = 2;

            FileSize = (float) Get_FileSize(PI.TempFile1);
            sprintf(StatusText,"Compressing %.3f KB", (float) FileSize / 1024 );
            PI.StatusText = StatusText;
            Result = LZARICompress(PI.TempFile1, PI.TempFile2);
            if(!Result)
            {
                PI.ErrorFlag = TRUE;
                PI.AfterText = FinishedWE;
                return FALSE;
            }

            if(PI.CancelFlag == TRUE)
            {
                PI.CompleteFlag = TRUE;
                return FALSE;
            }

            FileSize = (float) Get_FileSize(PI.TempFile2);
            sprintf(StatusText,"Encrypting %.3f KB", (float) FileSize / 1024 );
            PI.StatusText = StatusText;
            Result = BlowFishEncode(PI.TempFile2, PI.GlobalTarget, PI.Password);
            if(!Result)
            {
                PI.ErrorFlag = TRUE;
                PI.AfterText = FinishedWE;
                return FALSE;
            }

            if(PI.CancelFlag == TRUE)
            {
                PI.CompleteFlag = TRUE;
                return FALSE;
            }

            PI.CompleteFlag = TRUE;
            PI.AfterText = "Data Successfully Packaged!";
            return TRUE;
        }

        if(PI.CompressOption == FALSE)
        {
            PI.FileFlagResult = 1;

            FileSize = (float) Get_FileSize(PI.TempFile1);
            sprintf(StatusText,"Encrypting %.3f KB", (float) FileSize / 1024 );
            PI.StatusText = StatusText;
            Result = BlowFishEncode(PI.TempFile1, PI.GlobalTarget, PI.Password);
            if(!Result)
            {
                PI.ErrorFlag = TRUE;
                PI.AfterText = FinishedWE;
                return FALSE;
            }

            if(PI.CancelFlag == TRUE)
            {
                PI.CompleteFlag = TRUE;
                return FALSE;
            }

            PI.CompleteFlag = TRUE;
            PI.AfterText = "Data Successfully Packaged!";
            return TRUE;
        }

        PI.CompleteFlag = TRUE;
        return FALSE;
    }

    //------------------------------------------------------------------------------------

    if(PI.PreCheckResult == 2) // Encrypted File
    {
        FileSize = (float) Get_FileSize(PI.GlobalSource);
        sprintf(StatusText,"Decrypting %.3f KB", (float) FileSize / 1024 );
        PI.StatusText = StatusText;
        Result = BlowFishDecode(PI.GlobalSource, PI.GlobalTarget, PI.Password);
        if(!Result)
        {
            PI.ErrorFlag = TRUE;
            PI.AfterText = FinishedWE;
            return FALSE;
        }

        if(PI.CancelFlag == TRUE)
        {
            PI.CompleteFlag = TRUE;
            return FALSE;
        }

        if(Result == 2)
        {
            PI.CancelFlag = TRUE;
            PI.ErrorFlag = TRUE;
            PI.CompleteFlag = TRUE;
            PI.AfterText = WrongPWCD;
            return FALSE;
        }

        PI.CompleteFlag = TRUE;
        PI.AfterText = "Data Successfully Decrypted!";
        return TRUE;
    }

    //------------------------------------------------------------------------------------

    if(PI.PreCheckResult == 3) // Packed, Encrypted Directory
    {
        FileSize = (float) Get_FileSize(PI.GlobalSource);
        sprintf(StatusText,"Decrypting %.3f KB", (float) FileSize / 1024 );
        PI.StatusText = StatusText;
        Result = BlowFishDecode(PI.GlobalSource, PI.TempFile1, PI.Password);
        if(!Result)
        {
            PI.ErrorFlag = TRUE;
            PI.AfterText = FinishedWE;
            return FALSE;
        }

        if(PI.CancelFlag == TRUE)
        {
            PI.CompleteFlag = TRUE;
            return FALSE;
        }

        if(Result == 2)
        {
            PI.CancelFlag = TRUE;
            PI.ErrorFlag = TRUE;
            PI.CompleteFlag = TRUE;
            PI.AfterText = WrongPWCD;
            return FALSE;
        }

        FileSize = (float) Get_FileSize(PI.TempFile1);
        sprintf(StatusText,"Unpacking %.3f KB", (float) FileSize / 1024 );
        PI.StatusText = StatusText;
        Result = UnPackFiles(PI.TempFile1, PI.GlobalTarget);
        if(!Result)
        {
            PI.ErrorFlag = TRUE;
            PI.AfterText = FinishedWE;
            return FALSE;
        }

        if(PI.CancelFlag == TRUE)
        {
            PI.CompleteFlag = TRUE;
            return FALSE;
        }

        PI.CompleteFlag = TRUE;
        PI.AfterText = "Data Successfully Unpackaged!";
        return TRUE;
    }

    //------------------------------------------------------------------------------------

    if(PI.PreCheckResult == 4) // Compressed, Encrypted File
    {
        FileSize = (float) Get_FileSize(PI.GlobalSource);
        sprintf(StatusText,"Decrypting %.3f KB", (float) FileSize / 1024 );
        PI.StatusText = StatusText;
        Result = BlowFishDecode(PI.GlobalSource, PI.TempFile1, PI.Password);
        if(!Result)
        {
            PI.ErrorFlag = TRUE;
            PI.AfterText = FinishedWE;
            return FALSE;
        }

        if(PI.CancelFlag == TRUE)
        {
            PI.CompleteFlag = TRUE;
            return FALSE;
        }

        if(Result == 2)
        {
            PI.CancelFlag = TRUE;
            PI.ErrorFlag = TRUE;
            PI.CompleteFlag = TRUE;
            PI.AfterText = WrongPWCD;
            return FALSE;
        }

        FileSize = (float) Get_FileSize(PI.TempFile1);
        sprintf(StatusText,"Decompressing %.3f KB", (float) FileSize / 1024 );
        PI.StatusText = StatusText;
        Result = LZARIDecompress(PI.TempFile1, PI.GlobalTarget);
        if(!Result)
        {
            PI.ErrorFlag = TRUE;
            PI.AfterText = FinishedWE;
            return FALSE;
        }

        if(PI.CancelFlag == TRUE)
        {
            PI.CompleteFlag = TRUE;
            return FALSE;
        }

        PI.CompleteFlag = TRUE;
        PI.AfterText = "Data Successfully Decrypted!";
        return TRUE;
    }

    //------------------------------------------------------------------------------------

    if(PI.PreCheckResult == 5) // Packed, Compressed, Encrypted Directory
    {
        FileSize = (float) Get_FileSize(PI.GlobalSource);
        sprintf(StatusText,"Decrypting %.3f KB", (float) FileSize / 1024 );
        PI.StatusText = StatusText;
        Result = BlowFishDecode(PI.GlobalSource, PI.TempFile1, PI.Password);
        if(!Result)
        {
            PI.ErrorFlag = TRUE;
            PI.AfterText = FinishedWE;
            return FALSE;
        }

        if(PI.CancelFlag == TRUE)
        {
            PI.CompleteFlag = TRUE;
            return FALSE;
        }

        if(Result == 2)
        {
            PI.CancelFlag = TRUE;
            PI.ErrorFlag = TRUE;
            PI.CompleteFlag = TRUE;
            PI.AfterText = WrongPWCD;
            return FALSE;
        }

        FileSize = (float) Get_FileSize(PI.TempFile1);
        sprintf(StatusText,"Decompressing %.3f KB", (float) FileSize / 1024 );
        PI.StatusText = StatusText;
        Result = LZARIDecompress(PI.TempFile1, PI.TempFile2);
        if(!Result)
        {
            PI.ErrorFlag = TRUE;
            PI.AfterText = FinishedWE;
            return FALSE;
        }

        if(PI.CancelFlag == TRUE)
        {
            PI.CompleteFlag = TRUE;
            return FALSE;
        }

        FileSize = (float) Get_FileSize(PI.TempFile2);
        sprintf(StatusText,"Unpacking %.3f KB", (float) FileSize / 1024 );
        PI.StatusText = StatusText;
        Result = UnPackFiles(PI.TempFile2, PI.GlobalTarget);
        if(!Result)
        {
            PI.ErrorFlag = TRUE;
            PI.AfterText = FinishedWE;
            return FALSE;
        }

        if(PI.CancelFlag == TRUE)
        {
            PI.CompleteFlag = TRUE;
            return FALSE;
        }

        PI.CompleteFlag = TRUE;
        PI.AfterText = "Data Successfully Unpackaged!";
        return TRUE;
    }

    //------------------------------------------------------------------------------------

    if(PI.PreCheckResult == 6) // Non-448Delta File (Unencrypted)
    {
        if(PI.CompressOption == TRUE)
        {
            PI.FileFlagResult = 4;

            FileSize = (float) Get_FileSize(PI.GlobalSource);
            sprintf(StatusText,"Compressing %.3f KB", (float) FileSize / 1024 );
            PI.StatusText = StatusText;
            Result = LZARICompress(PI.GlobalSource, PI.TempFile1);
            if(!Result)
            {
                PI.ErrorFlag = TRUE;
                PI.AfterText = FinishedWE;
                return FALSE;
            }

            if(PI.CancelFlag == TRUE)
            {
                PI.CompleteFlag = TRUE;
                return FALSE;
            }

            FileSize = (float) Get_FileSize(PI.TempFile1);
            sprintf(StatusText,"Encrypting %.3f KB", (float) FileSize / 1024 );
            PI.StatusText = StatusText;
            Result = BlowFishEncode(PI.TempFile1, PI.GlobalTarget, PI.Password);
            if(!Result)
            {
                PI.ErrorFlag = TRUE;
                PI.AfterText = FinishedWE;
                return FALSE;
            }

            if(PI.CancelFlag == TRUE)
            {
                PI.CompleteFlag = TRUE;
                return FALSE;
            }

            PI.CompleteFlag = TRUE;
            PI.AfterText = "Data Successfully Encrypted!";
            return TRUE;
        }

        if(PI.CompressOption == FALSE)
        {
            PI.FileFlagResult = 3;

            FileSize = (float) Get_FileSize(PI.GlobalSource);
            sprintf(StatusText,"Encrypting %.3f KB", (float) FileSize / 1024 );
            PI.StatusText = StatusText;
            Result = BlowFishEncode(PI.GlobalSource, PI.GlobalTarget, PI.Password);
            if(!Result)
            {
                PI.ErrorFlag = TRUE;
                PI.AfterText = FinishedWE;
                return FALSE;
            }

            if(PI.CancelFlag == TRUE)
            {
                PI.CompleteFlag = TRUE;
                return FALSE;
            }

            PI.CompleteFlag = TRUE;
            PI.AfterText = "Data Successfully Encrypted!";
            return TRUE;
        }

        PI.CompleteFlag = TRUE;
        return FALSE;
    }

    //------------------------------------------------------------------------------------

    PI.CompleteFlag = TRUE;
    return FALSE;
}

///////////////////////////////////////////////////////////////////////////////////////////

DWORD WINAPI StartProcess_Thread(LPVOID xData)
{
    BOOL Result = StartProcess();

    EnableWindow(PI.OKCancelButton_hWnd, FALSE);

    if(PI.DestroyTempOption)
    {
        PI.StatusText = "Destroying Temp Files...";
        DestroyTemps();
        Sleep(150);
    }

    if(PI.CancelFlag || PI.ErrorFlag)
    {
        PI.StatusText = NULL;
        Set_Text(PI.StatusText_hWnd, "Deleting Target...");
        xDeleteObject(PI.GlobalTarget);
        Sleep(150);
        if(PI.CancelFlag) Set_Text(PI.StatusText_hWnd, "Canceled...");
        Sleep(150);
    }

    if(PI.DeleteSourceOption && !PI.CancelFlag && !PI.ErrorFlag )
    {
        Set_Text(PI.StatusText_hWnd, "Deleting Source File(s)...");
        xDeleteObject(PI.GlobalSource);
        Sleep(150);
    }

    if(PI.AfterText) Set_Text(PI.StatusText_hWnd, PI.AfterText);

    Sleep(150);

    if( !PI.CancelFlag && !PI.ErrorFlag && PI.CreateSelfOption)
    {
        char StringBuffer[1024];
        unsigned long SizeOfStringBuffer = sizeof(StringBuffer);

        if(Get_StringRegistryValue(HKEY_LOCAL_MACHINE, PathKey, "SelfAppend", StringBuffer, SizeOfStringBuffer))
        {
            if(FileAccess(StringBuffer, FExist)) // If SelfAppend Exist
            {
                CheckDlgButton(StatusDialog_hWnd, 5000, BST_UNCHECKED);
                SetWindowPos(StatusDialog_hWnd, HWND_NOTOPMOST, 0, 0, 0, 0, SWP_NOMOVE | SWP_NOSIZE);
                ShellExecute(StatusDialog_hWnd, "open", StringBuffer, PI.GlobalTarget, "", SW_NORMAL);
            } else Error("SelfAppend not found. \r\nPlease reinstall 448Delta.");
        }
    }

    DeleteFile(PI.TempFile1);
    DeleteFile(PI.TempFile2);

    PI.CompleteFlag = TRUE;
    Set_Text(PI.OKCancelButton_hWnd, "OK");
    EnableWindow(PI.OKCancelButton_hWnd, TRUE);
    KillTimer(StatusDialog_hWnd,0);

    MessageBeep(MB_ICONASTERISK);

    return 0;
}

///////////////////////////////////////////////////////////////////////////////////////////

