///////////////////////////////////////////////////////////////////////////////////////////

void Error(char *xMessage)
{
	MessageBox(StatusDialog_hWnd, xMessage, TitleCaption, MB_SYSTEMMODAL);
}

/////////////////////////////////////////////////////////////////////

void SetText (HWND xDialog, char *xText)
{
	SendMessage(xDialog,(UINT)WM_SETTEXT,(WPARAM)0,(LPARAM)xText);
}

/////////////////////////////////////////////////////////////////////

char *GetText (HWND xDialog)
{
	char *ReturnTemp = NULL;
	int Length		 = 0;
	Length = GetWindowTextLength(xDialog) + 1;
	ReturnTemp = (char *) calloc(Length,1);
	GetWindowText(xDialog,ReturnTemp,Length);
	return ReturnTemp;
}

/////////////////////////////////////////////////////////////////////

void CenterWindow (HWND xDialog)
{
	RECT wRect;
	DWORD CordX;
	DWORD CordY;
	GetWindowRect(xDialog,&wRect);
	CordX = (GetSystemMetrics(SM_CXSCREEN) - (wRect.right-wRect.left)) / 2;
	CordY = (GetSystemMetrics(SM_CYSCREEN) - (wRect.bottom - wRect.top + GetSystemMetrics(SM_CYCAPTION))) / 2;
	SetWindowPos(xDialog,NULL,CordX,CordY,0,0,SWP_NOSIZE | SWP_NOZORDER);
}

/////////////////////////////////////////////////////////////////////

int Unpack(char *xInputName,char *xOutputName)
{
	DWORD Result   = 0;

	char DecryptTemp[257];
	sprintf(DecryptTemp,"%s\\%s",GetTempDirectory(),"DecryptTemp.Upd");

	char StatusTemp[1024];
	sprintf(StatusTemp,"Decrypting %d KBytes",Get_FileSize(xInputName)/1024);
	SetText(StatusText_hWnd,StatusTemp);

	Result = BlowFishDecode(xInputName, DecryptTemp, CodedKey);
	
	if(Result == 0)
	{
		Result = UnPackFiles(DecryptTemp,xOutputName);
		if(Result == 0)
		{
			SetText(StatusText_hWnd, OperationComplete);
		}
	}

	SetText(OkCancelButton_hWnd, XOk);

	if(CancelFlag == TRUE)
	{
		xDeleteObject(xOutputName);
		SetText(StatusText_hWnd, Canceled);
		EnableWindow(OkCancelButton_hWnd,TRUE);
	}

	DoneFlag = TRUE;

	return Result;
}

//////////////////////////////////////////////////////////////////////

int DecompressDecrypt(char *xInputName,char *xOutputName)
{
	DWORD Result   = 0;

	char DecryptTemp[257];
	sprintf(DecryptTemp,"%s\\%s",GetTempDirectory(),"DecryptTemp.Upd");
	char CompressTemp[257];
	sprintf(CompressTemp,"%s\\%s",GetTempDirectory(),"CompressTemp.Upd");

	char StatusTemp[1024];
	sprintf(StatusTemp,"Decrypting %d KBytes",Get_FileSize(xInputName)/1024);
	SetText(StatusText_hWnd,StatusTemp);

	Result = BlowFishDecode(xInputName, DecryptTemp, CodedKey);

	if(Result == 0)
	{
		sprintf(StatusTemp,"Decompressing %d KBytes",Get_FileSize(DecryptTemp)/1024);
		SetText(StatusText_hWnd,StatusTemp);
		Result = LZARIDecompress(DecryptTemp,xOutputName);
		if(Result == 0)
		{
			SetText(StatusText_hWnd, OperationComplete);
		}
	}

	SetText(OkCancelButton_hWnd, XOk);
	DoneFlag = TRUE;
	if(CancelFlag == TRUE)
	{
		xDeleteObject(xOutputName);
		SetText(StatusText_hWnd, Canceled);
		EnableWindow(OkCancelButton_hWnd,TRUE);
	}

	return Result;
}

//////////////////////////////////////////////////////////////////////

int DecompressUnpack(char *xInputName,char *xOutputName)
{
	DWORD Result   = 0;

	char DecryptTemp[257];
	sprintf(DecryptTemp,"%s\\%s",GetTempDirectory(),"DecryptTemp.Upd");
	char CompressTemp[257];
	sprintf(CompressTemp,"%s\\%s",GetTempDirectory(),"CompressTemp.Upd");

	char StatusTemp[1024];
	sprintf(StatusTemp,"Decrypting %d KBytes",Get_FileSize(xInputName)/1024);
	SetText(StatusText_hWnd,StatusTemp);

	Result = BlowFishDecode(xInputName, DecryptTemp, CodedKey);

	if(Result == 0)
	{
		sprintf(StatusTemp,"Decompressing %d KBytes",Get_FileSize(DecryptTemp)/1024);
		SetText(StatusText_hWnd,StatusTemp);
		Result = LZARIDecompress(DecryptTemp,CompressTemp);
		if(Result == 0)
		{
			Result = UnPackFiles(CompressTemp,xOutputName);
			if(Result == 0)
			{
				SetText(StatusText_hWnd, OperationComplete);
			}
		}
	}

	SetText(OkCancelButton_hWnd, XOk);
	DoneFlag = TRUE;
	if(CancelFlag == TRUE)
	{
		xDeleteObject(xOutputName);
		SetText(StatusText_hWnd, Canceled);
		EnableWindow(OkCancelButton_hWnd,TRUE);
	}

	return Result;
}

//////////////////////////////////////////////////////////////////////

int DecryptFile(char *xInputName,char *xOutputName)
{
	DWORD Result   = 0;

	char DecryptTemp[257];
	sprintf(DecryptTemp,"%s\\%s",GetTempDirectory(),"DecryptTemp.Upd");
	char CompressTemp[257];
	sprintf(CompressTemp,"%s\\%s",GetTempDirectory(),"CompressTemp.Upd");

	char StatusTemp[1024];
	sprintf(StatusTemp,"Decrypting %d KBytes",Get_FileSize(xInputName)/1024);
	SetText(StatusText_hWnd,StatusTemp);

	Result = BlowFishDecode(xInputName, xOutputName, CodedKey);

	if(Result == 0)
	{
		SetText(StatusText_hWnd, OperationComplete);
	}

	SetText(OkCancelButton_hWnd, XOk);
	DoneFlag = TRUE;
	if(CancelFlag == TRUE)
	{
		xDeleteObject(xOutputName);
		SetText(StatusText_hWnd, Canceled);
		EnableWindow(OkCancelButton_hWnd,TRUE);
	}

	return Result;
}

//////////////////////////////////////////////////////////////////////

DWORD WINAPI UnPack_Thread(LPVOID data)
{
	char CleanSource[257];
	char CompressTemp[257];
	char DecryptTemp[257];

	int FlagResult = 0;
	DWORD Result   = 0;

	sprintf(DecryptTemp,"%s\\%s",GetTempDirectory(),"DecryptTemp.Upd");
	sprintf(CleanSource,"%s\\%s",GetTempDirectory(),"CleanSource.Upd");
	sprintf(CompressTemp,"%s\\%s",GetTempDirectory(),"CompressTemp.Upd");

	char *TargetDestination = Package.TargetDir;

	if(FileAccess(TargetDestination,FExist))
	{
		if(MessageBox(MainDialog_hWnd, "Target File Already Exist. Overwrite?" , TitleCaption, 0 + MB_YESNO + MB_DEFBUTTON2 + MB_ICONQUESTION) == IDNO)
		{
			SetText(StatusText_hWnd, Canceled);
			SetText(OkCancelButton_hWnd, XOk);
			DoneFlag = TRUE;
			return 0;
		}
	}

	FlagResult = PreCheckFile(SourceFileName);

	if(FlagResult == -1)
		Result = 1;
	if(FlagResult == 1)
		Result = DecryptFile(SourceFileName,TargetDestination);
	if(FlagResult == 2)
		Result = Unpack(SourceFileName,TargetDestination);
	if(FlagResult == 3)
		Result = DecompressDecrypt(SourceFileName,TargetDestination);
	if(FlagResult == 4)
		Result = DecompressUnpack(SourceFileName,TargetDestination);
	if(FlagResult == 5)
	{
		Error("Package is corrupt.");
		Result = 2;
	}

	SetText(OkCancelButton_hWnd, XOk);
	DoneFlag = TRUE;

	if(CancelFlag == TRUE)
	{
		SetText(StatusText_hWnd, Canceled);
		EnableWindow(OkCancelButton_hWnd,TRUE);
	}

	unlink(DecryptTemp);
	unlink(CleanSource);
	unlink(CompressTemp);

	return Result;
}

/////////////////////////////////////////////////////////////////////

void FreeMemory(void)
{
	while(Package.FolderCount != -1)
	{
		free(Package.FolderNames[Package.FolderCount]);
		Package.FolderNames[Package.FolderCount] = NULL;
		Package.FolderCount--;
	}

	while(Package.FileCount != -1)
	{
		free(Package.FileNames[Package.FileCount]);
		Package.FileNames[Package.FileCount] = NULL;
		Package.FileCount--;
	}
}

//////////////////////////////////////////////////////////////////////

char *GetTempDirectory(void)
{
	char *Name;
	Name = (char *) calloc(257,1);
	GetTempPath(256,Name);
	return Name;
}

//////////////////////////////////////////////////////////////////////

int PreCheckFile(char *FileToCheck)
{
	FILE *FileToCheck_File = NULL;
	char *Buffer = NULL;

	/* Check For File Access */
	if(!FileAccess(FileToCheck,FExist)) // Check Exist
	{
		char ErrorTemp[1024];
		sprintf(ErrorTemp,"PreCheckFile: %s does not exist.", FileToCheck);
		Error(ErrorTemp);

		return -1;
	}

	if((FileToCheck_File = fopen(FileToCheck,"rb")) == NULL) // Check Read Access
	{
		Error("PreCheckFile: File Does Not Allow Read Access. Error 15.");
		return -1;
	}

	if(FileToCheck_File)fclose(FileToCheck_File);

	/* Open Source File */
	if((FileToCheck_File = fopen(FileToCheck,"rb")) == NULL)
	{
		char ErrorTemp[1024];
		sprintf(ErrorTemp,"PreCheckFile: Could not open %s for read.", FileToCheck);
		Error(ErrorTemp);
		return -1;
	}

	fseek(FileToCheck_File,ExecutableEnd,SEEK_SET); // Seek Past Executable

	Buffer = (char *) calloc(FlagLenght + 1, 1);

	/* Read File Flag ( If Any ) */
	fread(Buffer,sizeof(char),FlagLenght,FileToCheck_File);

	if(FileToCheck_File) fclose(FileToCheck_File);

	if(strcmp(Buffer, ENCFlag) == 0) // If File Encryted
	{
		if(Buffer) free(Buffer);
		return 1;
	}

	if(strcmp(Buffer, PACFlag) == 0) // If File Packed
	{
		if(Buffer) free(Buffer);
		return 2;
	}

	if(strcmp(Buffer, ENCCompress) == 0) // If File Compressed Encryted
	{
		if(Buffer) free(Buffer);
		return 3;
	}

	if(strcmp(Buffer, PACCompress) == 0) // If File Compressed Packed
	{
		if(Buffer) free(Buffer);
		return 4;
	}

	if(Buffer) free(Buffer);

	return 5; // If File Not Encrypted
}

//////////////////////////////////////////////////////////////////////

DWORD Get_FileSize(char *File2Size)
{
	HANDLE Source;
	DWORD size;
	Source = CreateFile(File2Size,GENERIC_READ,0,NULL,OPEN_EXISTING,0,NULL);
	size = GetFileSize(Source,NULL);
	if(size == HFILE_ERROR) return -1;
	CloseHandle(Source);
	return size;
}

//////////////////////////////////////////////////////////////////////

BOOL FileAccess(char *FileName, short Mode)
{
	if(access(FileName, Mode) == 0)
		return TRUE;
	return FALSE;
}

//////////////////////////////////////////////////////////////////////

BOOL IsDirectory(char *xRequest)
{
	int Attrib;
	Attrib = GetFileAttributes(xRequest);
	if(Attrib != 0xFFFFFFFF)
	{
		if(Attrib & FILE_ATTRIBUTE_DIRECTORY)
			return TRUE;
	}
	return FALSE;
}

//////////////////////////////////////////////////////////////////////////

